Require Import Metatheory.
Require Import FJ_Definitions.
Require Import CFJ_Definitions.
Require Import CFJ_Facts.
Require Import CFJ_Lemmas.

(********************************************************************)
(* GENERATION PRESERVES TYPING                                      *)
(********************************************************************)

Theorem gpt_mutual_typing : (*$\label{gpt_mutual_typing}$*)
    ( forall (t:a_exp) (t':exp),
      variant_term t t' ->
      ( forall (a:ann) (E:a_env) (C:cname) (E':env),
        a_typing a E t C ->
        a ->
        variant_env E E' ->
        typing E' t' C ) /\
      ( forall (a:ann) (E:a_env) (C:cname) (E':env),
        a_wide_typing a E t C ->
        a ->
        variant_env E E' ->
        wide_typing E' t' C ) ) /\
    ( forall (ts:list (ann*a_exp)) (ts':list exp),
      variant_terms ts ts' ->
      forall (a:ann) (E:a_env) (Cxs:a_env) (E':env) (Cxs':env),
        a_wide_typings a E ts (imgs Cxs) ->
        a ->
        variant_env E E' ->
        variant_terms ts ts' ->
        variant_env Cxs Cxs' ->
        wide_typings E' ts' (imgs Cxs') ).
Proof.
  apply variant_term_mutind; intros; try (split; intros).
    inversion_clear H; subst.
    apply t_var.
      apply ok_env with (E:=E); eauto.

      apply variable_present with (a:=a') (E:=E); eauto.

    inversion_clear H; subst.
    apply wt_sub with (t:=t); eauto.
      inversion_clear H2; subst.
      apply t_var.
        apply ok_env with (E:=E); eauto.

        apply variable_present with (a:=a') (E:=E); eauto.

      apply subtype_present; eauto.
      apply (type_present a E (ae_var x)); eauto.

    destruct H0.
    inversion_clear H1; subst.
    apply t_field with (t0:=C0); eauto.
    apply field_present; eauto.

    destruct H0.
    inversion_clear H1; subst.
    apply wt_sub with (t:=t0); eauto.
      inversion_clear H5; subst.
      apply t_field with (t0:=C0); eauto.
      apply field_present; eauto.

      apply subtype_present; eauto.
      apply (type_present a E (ae_field t f)); eauto.

    destruct H0.
    inversion_clear H3; subst.
    destruct method_present' with (a:=a) (C:=C0) (C0:=C) (m:=m)
      (Dys:=Dys) (t:=t1) as [Dys' [t1' [Hve [Hvt Hm]]]]; eauto.
    apply (type_present a E t); eauto.

    destruct H0.
    inversion_clear H3; subst.
    apply wt_sub with (t:=t0); eauto.
      inversion_clear H7; subst.
      destruct method_present' with (a:=a) (C:=C0) (C0:=t0) (m:=m)
        (Dys:=Dys) (t:=t2) as [Dys' [t1' [Hve [Hvt Hm]]]]; eauto.
      apply (type_present a E t); eauto.

      apply subtype_present; eauto.
      apply (type_present a E (ae_meth t m ts)); eauto.

    inversion_clear H1; subst.
    destruct fields_present with (C:=C0) (fs:=Dfs) as [Dfs' [Ha Hb]];
      eauto.

    inversion_clear H1; subst.
    apply wt_sub with (t:=t); eauto.
      inversion_clear H4; subst.
      destruct fields_present with (C:=t) (fs:=Dfs) as [Dfs' [Ha Hb]];
        eauto.

      apply subtype_present; eauto.
      apply (type_present a E (ae_new C ts)); eauto.

    inversion H; subst.
    unfold imgs in H4.
    induction Cxs.
      inversion H3; subst.
      simpl.
      apply wts_nil; apply ok_env with (E:=E); eauto.

      discriminate H4.

    destruct H3.
    inversion H8; subst.
      simpl in H4.
      inversion H4.

      inversion_clear H4; subst.
      simpl.
      apply wts_cons.
        apply H0 with (a:=a0) (E:=E) (Cxs:=E0); assumption.

        apply H9 with (a:=a) (E:=E); auto.

      inversion_clear H4; subst.
      inversion_clear H7; subst.
        contradict H11; tauto.

        contradict H16; tauto.

    inversion H6; subst.
      inversion H2.

      inversion_clear H2; subst.
      inversion_clear H5; subst.
        contradict H10; tauto.

        contradict H13; tauto.

      inversion_clear H2; subst.
      apply H0 with (a:=a0) (E:=E) (Cxs:=E0); assumption.
Qed.

Theorem gpt_wide_typing : (*$\label{gpt_wide_typing}$*)
  forall (a:ann) (E:a_env) (t:a_exp) (C:cname) (E':env) (t':exp),
    a_wide_typing a E t C ->
    a ->
    variant_env E E' ->
    variant_term t t' ->
    wide_typing E' t' C.
Proof.
  intros.
  destruct gpt_mutual_typing as (Hsub, _).
  destruct Hsub with (t:=t) (t':=t') as (_, Hwt);
    try apply Hwt with (a:=a); eauto.
Qed.

Theorem gpt_typing : (*$\label{gpt_typing}$*)
  forall (a:ann) (E:a_env) (t:a_exp) (C:cname) (E':env) (t':exp),
    a_typing a E t C ->
    a ->
    variant_env E E' ->
    variant_term t t' ->
    typing E' t' C.
Proof.
  intros.
  destruct gpt_mutual_typing as (Hsub, _).
  destruct Hsub with (t:=t) (t':=t') as (Ht, _);
    try apply Ht with (a:=a); eauto.
Qed.

Theorem gpt_ok_meth : (*$\label{gpt_ok_meth}$*)
  forall (C D C0:cname) (m:mname) (Cfs:a_env) (Cfs':env) (t:a_exp)
    (t':exp),
    a_ok_meth C D m C0 Cfs t ->
    AT C ->
    ATm C m ->
    variant_env Cfs Cfs' ->
    variant_term t t' ->
    ok_meth C D m C0 Cfs' t'.
Proof.
  intros C D C0 m Cfs Cfs' t t' Hokm HrC Hrm Hve Hvt.
  (*EDIT4 BEGIN*)
  (*destruct Hokm as [Hr [Hmc [Hco Hwt]]].*)
  destruct Hokm as [Hmc [Hco Hwt]].
  (*EDIT4 END*)
  unfold ok_meth; split.
    unfold can_override.
    intros C0' Cfs'0 t'0 Hm.
    destruct method_present_reverse with (a:=ATm C m) (C:=D) (C0:=C0')
      (m:=m) (Dys':=Cfs'0) (t':=t'0) as [Cfs0 [t0 [Hve2 [_ Hm2]]]];
      eauto.
    destruct Hco with (C0':=C0') (E':=Cfs0) (t:=t0) as [He H];
      eauto.
    split; try assumption.
    revert Hve Hve2 H Hrm; clear.
    intro Hve; revert Cfs0 Cfs'0.
    induction Hve; intros.
      destruct Cfs0; [inversion Hve2; auto | inversion H].

      destruct Cfs0; inversion H0; subst.
      inversion Hve2; subst.
        assert (He:imgs E' = imgs E'0)
          by (apply IHHve with (Cfs0:=Cfs0); auto).
        simpl; rewrite He; trivial.

        contradict H7; tauto.

      destruct Cfs0; inversion H0; subst.
      inversion Hve2; subst.
        contradict H7; tauto.

        apply IHHve with (Cfs0:=Cfs0); auto.

    apply gpt_wide_typing with (a:=ATm C m) (E:=(this,(AT C,C))::Cfs)
      (t:=t); eauto.
Qed.

Theorem gpt_ok_class : (*$\label{gpt_ok_class}$*)
  forall (C D:cname) (fs:a_flds) (fs':flds) (ms:a_mths) (ms':mths),
    a_ok_class C D fs ms ->
    AT C ->
    variant_env fs fs' ->
    variant_methods C ms ms' ->
    ok_class C D fs' ms'.
Proof.
  intros C D fs fs' ms ms' Hokc HrC Hve Hvm.
  unfold ok_class.
  repeat split.
    destruct Hokc as [[gs [Hf [Hokcc Hok]]] [HrD [Hokms Hfa]]]; subst.
    destruct fields_present with (C:=D) (fs:=gs) as [gs' [Ha Hb]];
      eauto.
    exists gs'.
    split; eauto.
    apply ok_env_env with (F:=fs) (E:=gs); eauto.

    induction Hvm; try apply ok_nil.
      apply ok_cons.
        apply IHHvm; eauto.
        revert Hokc; clear; intro.
        destruct Hokc as [[gs [Hf [Hokcc Hokfs]]] [Hr [Hokms Hfa]]].
        unfold a_ok_class.
        repeat split; auto.
          exists gs.
          repeat split; try inversion Hokcc; auto.

          inversion Hokms; auto.

          apply fa_weaken with (E:=nil)
            (F:=(m,(ATm C m,(C0,Cxs,t)))::nil); auto.

        inversion_clear Hokc; subst.
        destruct H3 as [Hr [Hokms Hfa]].
        inversion_clear Hokms; subst.
        apply no_binds_ms with (C:=C) (ms:=ms); assumption.

      apply IHHvm; eauto.
      revert Hokc; clear; intro.
      destruct Hokc as [[gs [Hf [Hokcc Hokfs]]] [Hr [Hokms Hfa]]].
      unfold a_ok_class.
      repeat split; auto.
        exists gs.
        repeat split; try inversion Hokcc; auto.

        inversion Hokms; auto.

        apply fa_weaken with (E:=nil)
          (F:=(m,(ATm C m,(C0,Cxs,t)))::nil); auto.

    inversion_clear Hokc as [Ha Hb]; subst.
    destruct Hb as [Hr [Hokms Hfa]].
    induction Hvm; try apply fa_nil.
      apply fa_cons.
        inversion_clear Hfa; subst.
        apply IHHvm; try assumption.
          (*EDIT1 BEGIN*)
          (*intros.
          destruct H1 with (gs:=gs); clear H1.*)
          inversion_clear Ha as [gs Hb]; subst.
          destruct Hb as [Hf [Hokcc Hok]].
          exists gs.
          repeat split; try inversion Hokcc; assumption.
          (*EDIT1 END*)

          inversion Hokms; assumption.

        inversion_clear Hfa; subst.
        unfold a_ok_meth' in H3.
        unfold ok_meth'.
        apply gpt_ok_meth with (Cfs:=Cxs) (t:=t); eauto.

      apply IHHvm; try assumption.
        (*EDIT1 BEGIN*)
        (*intros.
        destruct H1 with (gs:=gs); clear H1.*)
        inversion_clear Ha as [gs Hb]; subst.
        destruct Hb as [Hf [Hokcc Hok]].
        exists gs.
        repeat split; try inversion Hokcc; assumption.
        (*EDIT1 END*)

        inversion Hokms; subst; assumption.

        inversion Hfa; assumption.
Qed.

Theorem gpt_ok_ctable : (*$\label{gpt_ok_ctable}$*)
  forall (ct:a_ctable) (ct':ctable),
    a_ok_ctable ct ->
    variant_ct ct ct' ->
    ok_ctable ct'.
Proof.
  intros.
  induction H0.
    unfold ok_ctable.
    split.
      apply ok_nil.

      apply fa_nil.

    unfold ok_ctable in IHvariant_ct.
    unfold ok_ctable.
    unfold a_ok_ctable in IHvariant_ct.
    inversion_clear H; subst.
    inversion_clear H4; subst.
    inversion_clear H5; subst.
    split.
      apply ok_cons.
        apply IHvariant_ct; split; assumption.

        apply no_binds_ct with (ct:=ct); assumption.

      apply fa_cons.
        apply IHvariant_ct; split; assumption.

        unfold a_ok_class' in H7.
        unfold ok_class'.
        apply gpt_ok_class with (fs:=fs) (ms:=ms); assumption.

    apply IHvariant_ct.
    unfold a_ok_ctable in *.
    destruct H.
    split; [inversion H | inversion H2]; subst; assumption.
Qed.

(* every FJ program variant generated from a well-typed SPL is
   well-typed *) 
Theorem generation_preserves_typing :
  forall (t:a_exp) (t':exp), (*$\label{generation_preserves_typing}$*)
    CFJ_product_line t ->
    variant_ct aCT CT ->
    variant_term t t' ->
    FM ->
    FJ_program t'.
Proof.
  intros t t' Hcfj Hcta Hvt Hfm.
  unfold FJ_program.
  split; inversion_clear Hcfj as [Hokct Ht]; subst.
    apply gpt_ok_ctable with (ct:=aCT); eauto.

    inversion_clear Ht as (C).
    exists C.
    apply gpt_typing with (a:=True) (E:=nil) (t:=t); eauto.
Qed.

(*Print Assumptions generation_preserves_typing.*)
